#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>



#include <gtk/gtk.h> 

#include <gmodule.h>




#include "nSX2.h"
#include "PS2Edefs.h"


#include "Sif.h"


u32  (* PS2EgetLibTypeGS)();
u32  (* PS2EgetLibVersionGS)();
char*(* PS2EgetLibNameGS)();

u32  (* PS2EgetLibTypePAD)();
u32  (* PS2EgetLibVersionPAD)();
char*(* PS2EgetLibNamePAD)();


_u8 LoadGsPluggin( char * filename ) {

    GModule*  handle;
      
    gboolean   my_result ; 
    _u8         nbErrors=0;


    handle = g_module_open (filename,    G_MODULE_BIND_LAZY);

    if ( handle == NULL ) {
        printf("ERROR LOAD DLL\n");
        return;
    }
    
    my_result = g_module_symbol (handle, "PS2EgetLibType", (gpointer*)&(PS2EgetLibTypeGS));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PS2EgetLibVersion", (gpointer*)&(PS2EgetLibVersionGS));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PS2EgetLibName", (gpointer*)&(PS2EgetLibNameGS));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSinit", (gpointer*)&(GSinit));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSopen", (gpointer*)&(GSopen));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSclose", (gpointer*)&(GSclose));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSvsync", (gpointer*)&(GSvsync));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSshutdown", (gpointer*)&(GSshutdown));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSwrite32", (gpointer*)&(GSwrite32));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSwrite64", (gpointer*)&(GSwrite64));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSread32", (gpointer*)&(GSread32));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSread64", (gpointer*)&(GSread64));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSgifTransfer", (gpointer*)&(GSgifTransfer));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSgifTransfer2", (gpointer*)&(GSgifTransfer2));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSkeyEvent", (gpointer*)&(GSkeyEvent));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSmakeSnapshot", (gpointer*)&(GSmakeSnapshot));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSconfigure", (gpointer*)&(GSconfigure));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GStest", (gpointer*)&(GStest));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "GSabout", (gpointer*)&(GSabout));
    if ( my_result == FALSE ) nbErrors++;

	return ( nbErrors );
}


_u8 LoadInputPluggin( char * filename ) {

    GModule*  handle;
      
    gboolean   my_result ; 
    _u8         nbErrors=0;


    handle = g_module_open (filename,    G_MODULE_BIND_LAZY);

    if ( handle == NULL ) {
        printf("ERROR LOAD DLL\n");
        return;
    }
    my_result = g_module_symbol (handle, "PS2EgetLibType", (gpointer*)&(PS2EgetLibTypePAD));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PS2EgetLibVersion", (gpointer*)&(PS2EgetLibVersionPAD));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PS2EgetLibName", (gpointer*)&(PS2EgetLibNamePAD));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADinit", (gpointer*)&(PAD1init));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADopen", (gpointer*)&(PAD1open));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADclose", (gpointer*)&(PAD1close));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADshutdown", (gpointer*)&(PAD1shutdown));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADkeyEvent", (gpointer*)&(PAD1keyEvent));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADstartPoll", (gpointer*)&(PAD1startPoll));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADquery", (gpointer*)&(PAD1query));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADconfigure", (gpointer*)&(PAD1configure));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADtest", (gpointer*)&(PAD1test));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADabout", (gpointer*)&(PAD1about));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "PADpoll", (gpointer*)&(PAD1poll));
    if ( my_result == FALSE ) nbErrors++;


	return ( nbErrors );
}


//SIF


void (CALLBACK* SIFGetDllInfo)(PLUGIN_INFO * _PluginInfo);
void (CALLBACK* SIFCloseDLL)(void);
void (CALLBACK* SIFDllAbout)(HWND _hParent);
void (CALLBACK* SIFDllConfig)(HWND _hParent);
void (CALLBACK* SIFDllTest)(HWND _hParent);
void (CALLBACK* SIFInitialize)(SSifInitialize _SifInitialize);
BOOL (CALLBACK* SIFBindModule)(SModuleBind* _pModuleBind); 
void (CALLBACK* SIFSetRPCVersion)(char* _ioprp); 



_u8 LoadSifPluggin( char * filename ) {

    GModule*  handle;
      
    gboolean   my_result ; 
    _s8         nbErrors=0;

	

    handle = g_module_open (filename,    G_MODULE_BIND_LAZY);

    if ( handle == NULL ) {
        printf("ERROR LOAD DLL\n");
        return;
    }

    my_result = g_module_symbol (handle, "GetDllInfo", (gpointer*)&(SIFGetDllInfo));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "CloseDLL", (gpointer*)&(SIFCloseDLL));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "DllAbout", (gpointer*)&(SIFDllAbout));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "DllConfig", (gpointer*)&(SIFDllConfig));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "Initialize", (gpointer*)&(SIFInitialize));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "BindModule", (gpointer*)&(SIFBindModule));
    if ( my_result == FALSE ) nbErrors++;

    my_result = g_module_symbol (handle, "SetRPCVersion", (gpointer*)&(SIFSetRPCVersion));
    if ( my_result == FALSE ) nbErrors++;

	return ( nbErrors );
}

/*******************************************************************/



extern SModuleBind nsx2SIFBindModule[SIF_PLUGGIN_MAX_BIND];
SSifInitialize	nsx2SifInitialize;

void* SifPluginGetMemoryPointer (DWORD _dwAddress) { 	return (&MipsMemory[_dwAddress & 0x01FFFFFF ]) ;}
void SifPluginSignalSema(int _dwSemaId) { 	Ps2Bios.Sema[ _dwSemaId ].currentCount = Ps2Bios.Sema[ _dwSemaId ].currentCount + 1; }
void SifPluginLog(char* _pMessage) { 	PrintToEmuOutput (  _pMessage ) ; }



_u8 BindSifPluggin( void  ) {
	
	_u8 nbErrors = 0;
    _u8   my_result ; 
	_u16	boucle;

	nsx2SifInitialize.pGetMemoryPointer = SifPluginGetMemoryPointer;
	nsx2SifInitialize.pSignalSema = SifPluginSignalSema;
	nsx2SifInitialize.pLog = SifPluginLog;


	(*SIFInitialize)(nsx2SifInitialize );
	
 	for (boucle=0; boucle<SIF_PLUGGIN_MAX_BIND; boucle++)
 	{
  		nsx2SIFBindModule[boucle].dwBindNumber = 0;
  		nsx2SIFBindModule[boucle].pCallFunction = NULL;
 	}  

	nsx2SIFBindModule[BIND_RPC_NPM_USER].dwBindNumber = RPC_NPM_USER ;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_RPC_NPM_USER]);
	if ( my_result == FALSE ) nbErrors++;	

/*
	nsx2SIFBindModule[BIND_CDVD_IRX].dwBindNumber = 0x80000001;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_CDVD_IRX]);
	if ( my_result == FALSE ) nbErrors++;
*/
	nsx2SIFBindModule[BIND_SJPCM_IRX].dwBindNumber = SJPCM_IRX;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_SJPCM_IRX]);
	if ( my_result == FALSE ) nbErrors++;	



	nsx2SIFBindModule[BIND_AMIGAMOD_IRX].dwBindNumber = AMIGAMOD_IRX;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_AMIGAMOD_IRX]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000001].dwBindNumber = 0x80000001;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000001]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x80000003].dwBindNumber = 0x80000003;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000003]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000400].dwBindNumber = 0x80000400;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000400]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000592].dwBindNumber = 0x80000592;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000592]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x80000593].dwBindNumber = 0x80000593;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000593]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000595].dwBindNumber = 0x80000595;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000595]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000596].dwBindNumber = 0x80000596;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000596]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000597].dwBindNumber = 0x80000597;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000597]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x8000059a].dwBindNumber = 0x8000059a;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000059a]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000601].dwBindNumber = 0x80000601;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000601]);
	if ( my_result == FALSE ) nbErrors++;



	nsx2SIFBindModule[BIND_0x8000010f].dwBindNumber = 0x8000010f;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000010f]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x8000011f].dwBindNumber = 0x8000011f;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x8000011f]);
	if ( my_result == FALSE ) nbErrors++;


	nsx2SIFBindModule[BIND_0x80000100].dwBindNumber = 0x80000100;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000100]);
	if ( my_result == FALSE ) nbErrors++;	


	nsx2SIFBindModule[BIND_0x80000101].dwBindNumber = 0x80000101;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000101]);
	if ( my_result == FALSE ) nbErrors++;

	nsx2SIFBindModule[BIND_0x80000006].dwBindNumber = 0x80000006;
	my_result = (* SIFBindModule)(&nsx2SIFBindModule[BIND_0x80000006]);
	if ( my_result == FALSE ) nbErrors++;

	return ( nbErrors );
}


